﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using HunterCommunication;

namespace TreasureHunter {
    public partial class Form1 : Form {
        public Form1() {
            InitializeComponent();
            comm = new HunterComm(toolStripComboBox1.Text);
            panel1.Invalidate();
            playNext("");
        }

        HunterComm comm;
        bool pcLogic = false;

        private void panel1_Paint(object sender, PaintEventArgs e) {
            Graphics g = e.Graphics;
            Pen pen = new Pen(Color.Gold, 2);
            
            Size s = new Size(panel1.Width, panel1.Height);
            SizeF cubeS = new SizeF((float)(panel1.Width / 10.0), (float)(panel1.Height / 10.0));
            Point p = new Point(0,0);

            for (int x = 0; x < 10; x++) {
                for (int y = 0; y < 10; y++) {
                    switch(comm.canvas[x,y]) {
                        case 0:
                            
                            break;
                        case -1:
                            g.FillRectangle(
                                new SolidBrush(Color.Black),
                                p.X + x * cubeS.Width,
                                p.Y + y * cubeS.Height,
                                cubeS.Width,
                                cubeS.Height
                            ); 
                            break;
                        case -10:
                            g.FillRectangle(
                                new SolidBrush(Color.Blue),
                                p.X + x * cubeS.Width,
                                p.Y + y * cubeS.Height,
                                cubeS.Width,
                                cubeS.Height
                            ); 
                            break;
                        case -11:
                            g.FillRectangle(
                                new SolidBrush(Color.Red),
                                p.X + x * cubeS.Width,
                                p.Y + y * cubeS.Height,
                                cubeS.Width,
                                cubeS.Height
                            ); 
                            break;
                        default:
                            g.DrawImage(
                                Image.FromFile("img/treasure.png"),
                                p.X + x * cubeS.Width,
                                p.Y + y * cubeS.Height,
                                cubeS.Width,
                                cubeS.Height
                            );
                            Font drawFont = new Font("Arial", 16);
                            SolidBrush drawBrush = new SolidBrush(Color.Blue);
                            StringFormat format = new StringFormat();
                            format.LineAlignment = StringAlignment.Center;
                            format.Alignment = StringAlignment.Center;
                            g.DrawString(
                                comm.canvas[x, y].ToString(),
                                drawFont, drawBrush,
                                new RectangleF(
                                    p.X + x * cubeS.Width,
                                    p.Y + y * cubeS.Height,
                                    cubeS.Width,
                                    cubeS.Height),
                                    format
                                );
                            break;
                    }
                } 
            }

            g.DrawImage(
                Image.FromFile("img/player.ico"),
                p.X + comm.p1X * cubeS.Width,
                p.Y + comm.p1Y * cubeS.Height,
                cubeS.Width,
                cubeS.Height
            );
            g.DrawEllipse(
                new Pen(Color.Blue, 2),
                p.X + comm.p1X * cubeS.Width,
                p.Y + comm.p1Y * cubeS.Height,
                cubeS.Width,
                cubeS.Height
            );

            label1.Text = "Skóre: " + comm.p1P.ToString();
            label2.Text = "Nesený poklad: " + comm.p1H.ToString();

            if (comm.isMultiplayer) {
                g.DrawImage(
                Image.FromFile("img/player.ico"),
                    p.X + comm.p2X * cubeS.Width,
                    p.Y + comm.p2Y * cubeS.Height,
                    cubeS.Width,
                    cubeS.Height
                );

                label3.Text = "Skóre: " + comm.p2P.ToString();
                label4.Text = "Nesený poklad: " + comm.p2H.ToString();
            }

            g.DrawRectangle(pen, p.X, p.Y, p.X + s.Width, p.Y + s.Height);
        }

        private void buttonUp_KeyDown(object sender, KeyEventArgs e) {
            string forSending = "";
            
            switch (e.KeyCode){
                case Keys.W:
                    forSending = "N";
                    break;
                case Keys.S:
                    forSending = "D";
                    break;
                case Keys.A:
                    forSending = "L";
                    break;
                case Keys.D:
                    forSending = "P";
                    break;
            }
                playNext(forSending);
        }

        private void celáObrazovkaToolStripMenuItem_Click(object sender, EventArgs e) {
            celáObrazovkaToolStripMenuItem.Checked = !celáObrazovkaToolStripMenuItem.Checked;
            if (celáObrazovkaToolStripMenuItem.Checked) {
                this.FormBorderStyle = FormBorderStyle.None;
                this.WindowState = FormWindowState.Maximized;
            } else {
                this.FormBorderStyle = FormBorderStyle.Sizable;
                this.WindowState = FormWindowState.Normal;
            }
        }

        private void nastaveníToolStripMenuItem_Click(object sender, EventArgs e) {

        }

        private void nováToolStripMenuItem_Click(object sender, EventArgs e) {
            comm = new HunterComm(toolStripComboBox1.Text);
            panel1.Invalidate();
        }

        private void nápovědaToolStripMenuItem_Click(object sender, EventArgs e) {

        }

        private void toolStripComboBox1_TextChanged(object sender, EventArgs e) {
            string uriName = toolStripComboBox1.Text;
            Uri uriResult;
            bool valid = Uri.TryCreate(uriName, UriKind.Absolute, out uriResult) && uriResult.Scheme == Uri.UriSchemeHttp;
            if (valid) {
                comm = new HunterComm(toolStripComboBox1.Text);
            } else {
                MessageBox.Show("Chybná adresa", "TreasureHunter", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void toolStripComboBox1_KeyDown(object sender, KeyEventArgs e) {
            if (e.KeyCode == Keys.Enter) {
                toolStripComboBox1_TextChanged(sender, null);
            }
        }

        private void panel1_SizeChanged(object sender, EventArgs e) {
            panel1.Invalidate();
        }

        private void buttonUp_MouseClick(object sender, MouseEventArgs e) {
            string forSending = "";

            switch (((Button)sender).Name) {
                case "buttonUp":
                    forSending = "N";
                    break;
                case "buttonDown":
                    forSending = "D";
                    break;
                case "buttonLeft":
                    forSending = "L";
                    break;
                case "buttonRight":
                    forSending = "P";
                    break;
            }

            playNext(forSending);
        }

        private void počítačováInteligenceToolStripMenuItem_Click(object sender, EventArgs e) {
            počítačováInteligenceToolStripMenuItem.Checked = !počítačováInteligenceToolStripMenuItem.Checked;
            if (počítačováInteligenceToolStripMenuItem.Checked) {
                pcLogic = true;
            } else {
                pcLogic = false;
            }
            comm = new HunterComm(toolStripComboBox1.Text);
            playNext("");
        }

        private void playNext(string forSending) {
            if (pcLogic) {
                string error = comm.playAuto();
                if (error != null) {
                    MessageBox.Show(error, "TreasureHunter", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
                panel1.Invalidate();
            } else {
                panel1.Invalidate();
                if (forSending != "") {
                    string error = comm.sendKey(forSending);
                    if (error != null) {
                        MessageBox.Show(error, "TreasureHunter", MessageBoxButtons.OK, MessageBoxIcon.Information);
                    }
                }
            }
        }
    }
}
